#include "Wire.h"
#include <BluetoothSerial.h>
#include "soc/soc.h"
#include "soc/rtc_cntl_reg.h"

#define PIN_DIR_WIR 4
#define PIN_PWM_WIR 2
#define PIN_ENC_WIR_A 17
#define PIN_ENC_WIR_B 16
#define DISTANCE 1470  //1400 1420
#define DIST 20//80
int wir=0;
int Move=2;
String MACadd = "78:21:84:F8:D2:92";
uint8_t address[6]  = {0x78, 0x21, 0x84, 0xF8, 0xD2, 0x92};
char *pin ="2301";
String n ="mirs";
BluetoothSerial SerialBT;
static volatile long count = 0;
bool con;


static void IRAM_ATTR enc_change() {
  int a_curr, b_curr;
  static int a_prev = LOW, b_prev = LOW;

  a_curr = digitalRead(PIN_ENC_WIR_A);
  b_curr = digitalRead(PIN_ENC_WIR_B);

  // 正転 : [L, H]→(L, L)→[H, L]→(H, H)→[L, H]
  if (a_prev ==  LOW && b_prev == HIGH && a_curr == HIGH && b_curr ==  LOW) count++;
  if (a_prev == HIGH && b_prev ==  LOW && a_curr ==  LOW && b_curr == HIGH) count++;

  // 逆転 : [L, L]→(L, H)→[H, H]→(H, L)→[L, L]
  if (a_prev ==  LOW && b_prev ==  LOW && a_curr == HIGH && b_curr == HIGH) count--;
  if (a_prev == HIGH && b_prev == HIGH && a_curr ==  LOW && b_curr ==  LOW) count--;

  a_prev = a_curr;
  b_prev = b_curr;
}

void encoder_open() {
  pinMode(PIN_ENC_WIR_A, INPUT);
  pinMode(PIN_ENC_WIR_B, INPUT);
  digitalWrite(PIN_ENC_WIR_A, HIGH);
  digitalWrite(PIN_ENC_WIR_B, HIGH);
  pinMode(17,INPUT_PULLUP);
  pinMode(16,INPUT_PULLUP);
  attachInterrupt(17, enc_change, CHANGE);
  //attachInterrupt(, enc_change_r, CHANGE);
}


void encoder_reset() {
  count = 0;
}

void blue_setup(){
    Serial.begin(115200);
    SerialBT.begin("ESP32_Client",true); // Bluetoothデバイスの名前を設定
    con = SerialBT.connect(address);
    if(con){
      Serial.println("connected");
    }else{
      Serial.println("faild to connect");
    }
}


void setup(){
  WRITE_PERI_REG(RTC_CNTL_BROWN_OUT_REG, 0);
  encoder_reset();
  motor_open();
  raspi_open();
  encoder_open();
  blue_setup();
 /* motor_set(80);
  delay(1000);
  motor_set2(-50);
  delay(5000);
  motor_set2(50);
  delay(1000);
  motor_set(-50);*/
}


void loop(){
  //motor_set(255);
  //esp32(0);
  if(!SerialBT.hasClient()){
    con = SerialBT.connect(address);
    if(con){
      Serial.println("connected");
    }else{
      Serial.println("faild to connect");
    }
  }
   if (wir ==1 && Move!=1) {
      Move=1;
      motor_set(100);
      Serial.println("complete1");
      
        //run_ctrl_get(&state, &speed, &dist);
   }else if(wir==2 && Move!=2 ){
      Move=2;
      motor_set(-60);
      Serial.println("complete2");
        
       // run_ctrl_get(&state, &speed, &dist);
   }else if(wir==3 && Move!=3 ){
      Move=3;
      motor_set2(80);
      Serial.println("complete3");
   }else if(wir==4 && Move!=4 ){
      Move=4;
      motor_set2(-50);
      Serial.println("complete3");
   }else if(wir==0){
      motor_set(0);
      Move=0;
   }else if(wir==5){;
      esp32(0);
      wir=0;
   }else if(wir==6){;
      esp32(1);
      wir=0;
   }else if(wir==7){;
      esp32(2);
      wir=0;
   }
   
   delay(50);
}
void wirData(int byteCount) {
  while (Wire.available()) {
    wir = Wire.read();
    Serial.println(wir);
   
  }
}


void distance_get(double *dist) {
  long enc;
  encoder_get(&enc);
}

void encoder_get(long *cnt) {
  *cnt=count;
  *cnt *= -1;
}



void motor_open(){
  pinMode(PIN_DIR_WIR, OUTPUT);
  pinMode(PIN_PWM_WIR, OUTPUT);
  ledcSetup(0, 12800, 8);
  ledcAttachPin(2, 0);
  //digitalWrite(PIN_PWM_WIR, 0);
}
void motor_set2(int pwm_wir){
  long dis =0;
  if (pwm_wir >  255) pwm_wir =  255;
  if (pwm_wir < -255) pwm_wir = -255;
  if (pwm_wir > 0) {//あげる
    while(1){
      digitalWrite(PIN_DIR_WIR, HIGH);
      ledcWrite(0, abs(pwm_wir));
      encoder_get(&dis);
      Serial.println("moving");
      Serial.print("count");
      Serial.println(count);
      if(count<-1 * DIST){
        digitalWrite(PIN_DIR_WIR, LOW);//停止
        ledcWrite(0, 0);
        Serial.println("down");
        break;
      }
    }
  } else if(pwm_wir<0){//下げる
    while(1){
      digitalWrite(PIN_DIR_WIR, LOW);
      ledcWrite(0, abs(pwm_wir));
      encoder_get(&dis);
      Serial.println("moving2");
      Serial.print("count");
      Serial.println(count);
      if(count>DIST){
        digitalWrite(PIN_DIR_WIR, LOW);//停止
        ledcWrite(0,0);
        Serial.println("down2");
        break;
      }
    }
  }else {//停止
    digitalWrite(PIN_DIR_WIR, LOW);
    ledcWrite(0, 0);
    Serial.println("down3");
  }
  encoder_reset();
}
void motor_set(int pwm_wir){
  long dis =0;
  if (pwm_wir >  255) pwm_wir =  255;
  if (pwm_wir < -255) pwm_wir = -255;
  if (pwm_wir > 0) {//あげる
    while(1){
      digitalWrite(PIN_DIR_WIR, HIGH);
      ledcWrite(0, abs(pwm_wir));
      encoder_get(&dis);
      Serial.println("moving");
      Serial.print("count");
      Serial.println(count);
      if(count<-1 * DISTANCE){
        digitalWrite(PIN_DIR_WIR, LOW);//停止
        ledcWrite(0, 0);
        Serial.println("down");
        break;
      }
    }
  } else if(pwm_wir<0){//下げる
    while(1){
      digitalWrite(PIN_DIR_WIR, LOW);
      ledcWrite(0, abs(pwm_wir));
      encoder_get(&dis);
      Serial.println("moving2");
      Serial.print("count");
      Serial.println(count);
      if(count>DISTANCE){
        digitalWrite(PIN_DIR_WIR, LOW);//停止
        ledcWrite(0,0);
        Serial.println("down2");
        break;
      }
    }
  }else {//停止
    digitalWrite(PIN_DIR_WIR, LOW);
    ledcWrite(0, 0);
    Serial.println("down3");
  }
  encoder_reset();
}
void raspi_open() {
  Serial.begin(115200);
  Wire.begin(0x8);  // I2Cアドレスを設定 (8は任意のアドレス)
  Wire.onReceive(wirData);
  //バッファのクリア
  while (Wire.available() > 0) {
    Wire.read();
  }
}

void esp32(int sendData){
    SerialBT.write(sendData);
    while(1){
      if (SerialBT.available()) {
          int data = SerialBT.read(); // 数字を読み取る
          Serial.print("Received from Server: ");
          Serial.println(data);
          break;
      }
    }
    return;
}
